

!!! Listing 1 dtd

<!ELEMENT online      ( jahr+ ) >

<!ELEMENT jahr        ( ausgabe+ ) >
<!ELEMENT ausgabe     ( artikel+ ) >
<!ELEMENT artikel     ( autor, schlagwort, dachzeile?, titel, seite ) >

<!ELEMENT autor       ( #PCDATA ) >
<!ELEMENT schlagwort  ( #PCDATA ) >
<!ELEMENT dachzeile   ( #PCDATA ) >
<!ELEMENT titel       ( #PCDATA ) >
<!ELEMENT seite       ( #PCDATA ) >

<!ATTLIST jahr
          which       CDATA   #REQUIRED >

<!ATTLIST ausgabe
          monat       CDATA   #REQUIRED >

<!ATTLIST artikel
          id          ID      #REQUIRED
          rubrik      ( mt | praxis | report | review | 
                        titel | wissen | sonst )   #REQUIRED 
          url         CDATA  #IMPLIED
          en_url      CDATA  #IMPLIED
          serie       ( perl | intinfo | edit |
                        www | linux | tcl | andere ) #IMPLIED >

!!! Listing 2 

database xyz

SELECT 

{ diverse Feldnamen, darunter: is_online }

 FROM artikeldaten
 WHERE is_online > " " 
 ORDER by jahr DESC, monat DESC, seite
END

FORMAT 

{ ----- Ausgabe der Online-Artikel in XML }

  ON EVERY ROW
	print '<artikel rubrik="', rubrik clipped, '"'
        print '         id="a', jahr using "&&", monat using "&&", seite using "&&&", '"'
	print '         serie="', serie clipped, '"' 
	print '         url="', url clipped, '"' 

	IF (en_url > " ") THEN
	print '         en_url="', en_url clipped, '"' 

	print '	        red="', redakteur clipped, '">'

	print "    <autor>", autor clipped, "</autor>"
	print "    <schlagwort>", schlagwort clipped, "</schlagwort>"
	print "    <titel>", titel clipped, "</titel>"
	print "    <seite>", seite using "<<<", "</seite>"
	print "</artikel>"
	print ""

	BEFORE GROUP OF jahr
	print '<jahr which="', jahr using "##", '">'

	BEFORE GROUP OF monat
	print '<ausgabe monat="', monat using "<<", '">'

	AFTER GROUP OF monat
	print "</ausgabe>"

	AFTER GROUP OF jahr
	print "</jahr>"
  END

!!! Listing 3 xml

<online>
  <jahr>
    <ausgabe>
     <artikel rubrik="praxis"
              id="a9810154"
              serie="perl"
              url="/ix/artikel/1998/10/154/"
              red="ck">
         <autor>Michael Schilli</autor>
         <schlagwort>Perl-Know-how</schlagwort>
         <dachzeile>Multithreading mit Perl 5.005</dachzeile>
         <titel>Aufgefdelt</titel>
         <seite>154</seite>
     </artikel>
<!-- weitere Artikel -->
    </ausgabe>
<!-- weitere Ausgaben -->
  </jahr>
<!-- weitere Jahrgnge -->
</online>

!!! Listing 4 dsssl

<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN">

; ----- [...]

; ----- Details pro Jahr -------------

(element jahr
	(if (equal? (attribute-string "WHICH" (current-node)) "98")
	    (make sequence
		(make element gi: "H1" 
		attributes: (cons (list "class" "year")
			'()) (literal (string-append "19" 
		(attribute-string "WHICH"))))
		(process-matching-children 'ausgabe))
	(empty-sosofo)))

; -------- das Heft

(element ausgabe
  (make sequence
     (make element gi: "h3"
      attributes: (cons (list "class" "ausg")
        '()) 
     (literal (getmonth 
       (string->number (attribute-string
       "MONAT")) monate "de")))

     (make element gi: "dl"
      (process-matching-children 'artikel))

     (make empty-element gi: "hr")

; -------- einzelne Artikel -------------

(element artikel
  (make sequence
; ---------------------- dt
      (make element gi: "dt" 
        attributes: (cons (list "class" "schlag")
        (cons (list "valign" "top")
        '())) (literal "[")
          (process-matching-children 'schlagwort)
          (literal "] ")

      (make element gi: "strong"
        attributes: (cons (list "class" "titel")
        '()) (process-matching-children 'titel)))
; --------------------------- dd
      (make element gi: "dd"
        attributes: (cons (list "class" "werte")
        '())
        (process-matching-children 'dachzeile)
; -------- auf Englisch vorhanden?
    (if (attribute-string "EN_URL")
        
    (make element gi: "strong"
      attributes: (cons (list "class" "titel")
        '())
      (literal " [ ")
      (make element gi: "a"
      attributes: (cons (list "href" (attribute-string "EN_URL"))
        '()) (literal "English"))
      (literal " ]"))
    (empty-sosofo)))))


!!! Listing 5

<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN" [

<!ENTITY top1 SYSTEM "../top1.dat" >
<!ENTITY func SYSTEM "functions.scm" >
<!ENTITY head SYSTEM "head.dat" >
<!ENTITY top2 SYSTEM "../top2.dat" >
<!ENTITY menu SYSTEM "menu.dat" >
<!ENTITY docline SYSTEM "default.l.dat" >
<!ENTITY pre SYSTEM "pre.dat" >
]>

&top1;
&func;
&head;
&top2;
&menu;
&docline;
&pre;
